#include "QSimulationLookTableDialog.h"
#include "ui_QSimulationLookTableDialog.h"
#include <QFileDialog>
#include <QMessageBox>
#include "LookTableComputerClass.h"

QSimulationLookTableDialog::QSimulationLookTableDialog(QWidget *parent)
	: QDialog(parent),ui(new Ui::QSimulationLookTableDialogClass)
{
	ui->setupUi(this);
}

QSimulationLookTableDialog::~QSimulationLookTableDialog()
{

}

void QSimulationLookTableDialog::onrejected()
{
	this->close();
}

void QSimulationLookTableDialog::onpushButtonOrbitModelClicked(bool)
{
	// ļѡԻѡһ .tif ļ
	QString fileName = QFileDialog::getOpenFileName(this,
		u8"GPS Orbit Model xml",          // Ի
		"",                        // ʼĿ¼Ϊ·
		u8"xml Files (*.xml)"); // ļ͹

	if (!fileName.isEmpty()) {
		this->ui->OrbitModelPathLineEdit->setText(fileName);
	}
	else {
		QMessageBox::information(this, u8"ûѡļ", u8"ûѡκļ");
	}
}

void QSimulationLookTableDialog::onpushButtonSataSettingClicked(bool)
{
	// ļѡԻѡһ .tif ļ
	QString fileName = QFileDialog::getOpenFileName(this,
		u8"Satellite Params setting xml",          // Ի
		"",                        // ʼĿ¼Ϊ·
		u8"xml Files (*.xml)"); // ļ͹

	if (!fileName.isEmpty()) {
		this->ui->SateSettingLineEdit->setText(fileName);
	}
	else {
		QMessageBox::information(this, u8"ûѡļ", u8"ûѡκļ");
	}
}

void QSimulationLookTableDialog::onpushButtonDEMClicked(bool)
{
	// ļѡԻѡһ .tif ļ
	QString fileName = QFileDialog::getOpenFileName(this,
		u8"DEM Raster Select",          // Ի
		"",                        // ʼĿ¼Ϊ·
		u8"tiff Files (*.tiff);;tif Files (*.tif);;dat Files (*.dat);;All Files (*.*)"); // ļ͹

	if (!fileName.isEmpty()) {
		this->ui->DEMLineEdit->setText(fileName);
	}
	else {
		QMessageBox::information(this, u8"ûѡļ", u8"ûѡκļ");
	}
}

void QSimulationLookTableDialog::onpushButtonOutDirClicked(bool)
{
	// ļѡԻѡһ .tif ļ
	QString fileName = QFileDialog::getExistingDirectory(this,
		u8"DEM Raster Select",          // Ի
		""                       // ʼĿ¼Ϊ·
		);
	if (!fileName.isEmpty()) {
		this->ui->outDirLineEdit->setText(fileName);
	}
	else {
		QMessageBox::information(this, u8"ûѡļ", u8"ûѡκļ");
	}
}

void QSimulationLookTableDialog::onaccepted()
{
	QString orbitpath = this->ui->OrbitModelPathLineEdit->text();
	QString SatePath = this->ui->SateSettingLineEdit->text();
	QString DEMPath = this->ui->DEMLineEdit->text();
	QString outDirPath = this->ui->outDirLineEdit->text();

	//double gridX = this->ui->doubleSpinBoxGridX->value();
	//double gridY = this->ui->doubleSpinBoxGridY->value();

	bool gpuflag = this->ui->radioButtonGPU->isChecked();
	bool looktableflag = this->ui->LookTableCheck->isChecked();
	bool checkBoxIncAngle = this->ui->checkBoxIncAngle->isChecked();
	bool BoxDopplerFlag = this->ui->checkBoxDoppler->isChecked();
	QString simulationName = this->ui->lineEditLookName->text();
	LookTableSimualtionMainProcessSpace::LookTableSimualtionMainProcess(
		simulationName,
		orbitpath, SatePath, DEMPath, outDirPath,
		gpuflag, looktableflag, checkBoxIncAngle, BoxDopplerFlag
	);




}
